* MDHEADR reads and returns file header information in buffer
*  PWITTE March 5th 1994
* V0.01
* V0.02, pjw, 2025 Mar 09, fixed stack problem
*
        section code

        include dev8_keys_qdos_io
        include dev8_keys_qdos_ioa
        include dev8_keys_sbasic

        xdef MDHEADR

        xref ut_stos
        xref chan_get
        xref chop
        xref mdinf
        xref ioclose
        xref resrir

md_hrperr
        moveq #-15,d0

md_hrret
        rts

MDHEADR
        moveq #8,d0
        add.l a3,d0
        sub.l a5,d0             one par?
        bne.s md_hrperr

        move.l sb_arthp(a6),d7  save "empty" stack pointer (FFS!)

        btst #nt..hash,1(a6,a3.l) preceded by hash?
        bne.s md_hr1            yes, so check if open

        bsr ut_stos             no, get file name
        tst.l d0
        bne.s md_hrret          oops
        bra.s md_hroch

md_hr1
        bsr chan_get
        bne.s md_hrret
        moveq #-1,d6            flag don't close
        bra.s md_hrcho

md_hroch
        moveq #ioa.kshr,d3      open_in shared
        trap #4

        bsr chop
        bne.s md_hrret
        moveq #0,d6             flag: close after use

md_hrcho
        bsr mdinf               find header length
        tst.l d0
        bmi.s mdc_hr
        move.l ioi_hdrl(a6,a1.l),d2     also buffer length
        bsr.s headr

mdc_hr
        tst.l d6
        beq.s mdc_hrc
        tst.l d0
        bra.s mdc_hrrts

mdc_hrc
        move.l d0,d1
        bsr ioclose
        move.l d1,d0

mdc_hrrts
        bmi md_hrret

        moveq #ar.strng,d4
        moveq #0,d0
        rts

headr
        moveq #2,d1
        add.l d2,d1
        move.l d7,sb_arthp(a6)
        bsr resrir

        move.w d2,0(a6,a1.l)       ;put string length in place
        addq.l #2,a1               ;chars go here
        moveq #forever,d3          ;timeout
        moveq #iof.rhdr,d0         ;fs.headr
        trap #4                    ;a6 rel
        trap #3

        movea.l sb_arthp(a6),a1    point to header as string
        rts

*
        end
