* Media Info toolkit
* P Witte 1994
* V1.05
*
* 0.02 Added MDREMV
* 0.03 DDLEVEL -> MDLEVEL (and bug fixes)
* 0.04 MDALLOC returns uint (as float)
* 0.05 Changed all keys to SMSQ/E, fixed stack bug
* 0.06 2021 Oct 27, Tidied code. Re-organised toolkits

        section code

        include dev8_keys_qlv
        include dev8_mac_proc


* Extended Media information
*
* Keywords to establish 1) Driver level ie 1, 2 or ...      MDLEVEL
*                       2) Allocation size                  MDALLOC
*                       3) File header size                 MDFHEAD
*                       4) Media size                       MDGOOD
*                       5) Free space on media              MDFREE
*                       6) Media name                       MDNAME$
*                       7) Read-only status (<>0=readonly)  MDSTAT  (dd2 only)
*                       8) Removable status (<>0=removable) MDREMV  (dd2 only)
*                       9) File space requirement           MDFSIZE
*                      10) Returns file header              MDHEADR$
*
* The following parameters are required:
* 1-8 'device' or 'filename', device or fileneme, or #channel_no.
*   9 as above, plus size of the file you wish to fit
*  10 'filename', filename, or #channel_no.


         lea.l   key,a1
         move.w  sb.inipr,a2
         jmp     (a2)

*
         dc.b 'MDINFO V0.06, pjwitte, 2021'
         ds.w 0         align
*
key
         proc_stt
         proc_end

         proc_stt
         proc_def MDLEVEL
         proc_def MDALLOC
         proc_def MDFHEAD
         proc_def MDGOOD
         proc_def MDFREE
         proc_def MDNAME$,MDNAME
         proc_def MDSTAT
         proc_def MDREMV
         proc_def MDFSIZE
         proc_def MDHEADR$,MDHEADR
         proc_end

*
         end
